<?php

namespace Modules\Cotacao\Modules\Pedido\Services;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO;
use Util\SupUtilities;
use \Teknisa\Libs\Util\Utilities as LibUtilities;
use Teknisa\Libs\Util\XLS\FileLoader;
use Teknisa\Libs\Util\XLS\FileReader;
use Teknisa\Libs\Util\XLS\Table;
use PHPExcel_Cell;
use PHPExcel_Worksheet;

class Sup09600IImportacaodeRFPService
{
    protected $entityManager;
    protected $environment;
    protected $connection;
    protected $utilities;
    protected $newCode;
    protected $errors = array();
    public function __construct($entityManager, $environment, $connection, SupUtilities $supUtilities, LibUtilities $utilities, $newCode)
    {
        $this->entityManager = $entityManager;
        $this->environment   = $environment;
        $this->connection    = $connection;
        $this->supUtilities  = $supUtilities;
        $this->utilities = $utilities;
        $this->newCode    = $newCode;
    }
    
    /********************
     *   TRANSACTIONS   *
     ********************/
    
    public function beginTransaction()
    {
        $this->entityManager->beginTransaction();
    }
    
    public function commitTransaction()
    {
        $this->entityManager->commit();
    }
    
    public function rollbackTransaction()
    {
        $this->entityManager->rollback();
    }
    
    public function getcentralCompras($cdfilial = null) 
    {
        return $this->supUtilities->getCentralCompras($cdfilial);
    }
    
    public function setError($rowNum, $columnName, $value, $message, $secondValue = null) {
        array_push(
            $this->errors, 
            array(
                "ROWNUM" => $rowNum,
                "COLUMN" => $columnName,
                "VALUE" => $value,
                "ERROR_CODE" => $message,
                "SECOND_VALUE" => $secondValue
            )
        );
    }

    public function readXlsHeader($row, $response){
            $file = $row['FILE'];
            $sheetsToLoad = array('Sheasdasdsadet1', 'Sheet1', 'Planilha1');
            $xlsFile = FileLoader::loadFromBase64($file['content'], $file['name']);
            if(!$xlsFile){
                throw new \Exception(self::IMPORT_LOAD_FILE_ERROR);
            }
            $worksheet = $xlsFile->getActiveSheet();
            $cellC1 = $worksheet->getCell('C1');//Nome Arquivo
            /*$cellO1 = $worksheet->getCell('O1');//Dados Arquivo
            //
            $cellE2 = $worksheet->getCell('E2');//Regiao
            $cellE3 = $worksheet->getCell('E3');//Regiao 1
            $cellE4 = $worksheet->getCell('E4');//Regiao 2
            $cellE5 = $worksheet->getCell('E5');//Regiao 3
            $cellE6 = $worksheet->getCell('E6');//Regiao 4
            $cellF3 = $worksheet->getCell('F3');//Regiao 5
            $cellF4 = $worksheet->getCell('F4');//Regiao 6
            $cellF5 = $worksheet->getCell('F5');//Regiao 7
            $cellF6 = $worksheet->getCell('F6');//Regiao 8
            //
            //$cellC2 = $worksheet->getCell('C2');//Validade*/ 
            $cellD3 = $worksheet->getCell('D3');//Validade Inicial
            $cellD4 = $worksheet->getCell('D4');//Validade Final
            /*$cellG2 = $worksheet->getCell('G2');//UF atendida
            $cellH2 = $worksheet->getCell('H2');//UF 1
            $cellH3 = $worksheet->getCell('H3');//UF 2
            $cellH4 = $worksheet->getCell('H4');//UF 3
            $cellH5 = $worksheet->getCell('H5');//UF 4
            $cellH6 = $worksheet->getCell('H6');//UF 5
            $cellI2 = $worksheet->getCell('I2');//UF 6
            $cellI3 = $worksheet->getCell('I3');//UF 7
            $cellI4 = $worksheet->getCell('I4');//UF 8
            $cellI5 = $worksheet->getCell('I5');//UF 9
            $cellI6 = $worksheet->getCell('I6');//UF 10
            //
            $cellJ2 = $worksheet->getCell('J2');//Exceção Regiao
            $cellJ3 = $worksheet->getCell('J3');//Exceção Regiao 1
            $cellJ4 = $worksheet->getCell('J4');//Exceção Regiao 2
            $cellJ5 = $worksheet->getCell('J5');//Exceção Regiao 3
            $cellJ6 = $worksheet->getCell('J6');//Exceção Regiao 4
            //
            //$cellK2 = $worksheet->getCell('K2');//Responsavel*/
            $cellM2 = $worksheet->getCell('M2');//Responsavel Nome
            /*$cellK3 = $worksheet->getCell('K3');//Email Responsavel
            $cellM3 = $worksheet->getCell('M3');//Email
            //
            $cellK5 = $worksheet->getCell('K5');//Filial
            $cellM5 = $worksheet->getCell('M5');//Filial Valor
            //
            $cellK6 = $worksheet->getCell('K6');//Versao
            $cellM6 = $worksheet->getCell('M6');//Versao Valor
            //
            $cellO2 = $worksheet->getCell('O2');//Regiao 2
            $cellO3 = $worksheet->getCell('O3');//Regiao 2 1
            $cellO4 = $worksheet->getCell('O4');//Regiao 2 2
            $cellO5 = $worksheet->getCell('O5');//Regiao 2 3
            $cellO6 = $worksheet->getCell('O6');//Regiao 2 4
            $cellP3 = $worksheet->getCell('P3');//Regiao 2 5
            $cellP4 = $worksheet->getCell('P4');//Regiao 2 6
            $cellP5 = $worksheet->getCell('P5');//Regiao 2 7
            $cellP6 = $worksheet->getCell('P6');//Regiao 2 8
            $cellQ3 = $worksheet->getCell('Q3');//Regiao 2 9
            $cellQ4 = $worksheet->getCell('Q4');//Regiao 2 10
            $cellQ5 = $worksheet->getCell('Q5');//Regiao 2 11
            $cellQ6 = $worksheet->getCell('Q6');//Regiao 2 12
            //
            //$cellA6 = $worksheet->getCell('A6');//Codigo comprador*/
            $cellB6 = $worksheet->getCell('B6');//Codigo comprador valor
            /*$cellA7 = $worksheet->getCell('A7');//Nome comprador
            $cellB7 = $worksheet->getCell('B7');//Nome comprador valor
            //
            $cellA8 = $worksheet->getCell('A8');//Nome fornecedor
            $cellB8 = $worksheet->getCell('B8');//Nome fornecedor valor
            //
            $cellC6 = $worksheet->getCell('C6');//DATA
            $cellD6 = $worksheet->getCell('D6');//DATA valor
            //
            $cellC8 = $worksheet->getCell('C8');//CNPJ 1
            $cellD8 = $worksheet->getCell('D8');//CNPJ 1 valor
            $cellF8 = $worksheet->getCell('F8');//CNPJ 2
            $cellG8 = $worksheet->getCell('G8');//CNPJ 2 valor
            $cellI8 = $worksheet->getCell('I8');//CNPJ 3
            $cellJ8 = $worksheet->getCell('J8');//CNPJ 3 valor
            $cellL8 = $worksheet->getCell('L8');//CNPJ 4
            $cellM8 = $worksheet->getCell('M8');//CNPJ 4 valor
            $cellO8 = $worksheet->getCell('O8');//CNPJ 5
            $cellP8 = $worksheet->getCell('P8');//CNPJ 5 valor
            $cellC9 = $worksheet->getCell('C9');//CNPJ 6
            $cellD9 = $worksheet->getCell('D9');//CNPJ 6 valor
            $cellF9 = $worksheet->getCell('F9');//CNPJ 7
            $cellG9 = $worksheet->getCell('G9');//CNPJ 7 valor
            $cellI9 = $worksheet->getCell('I9');//CNPJ 8
            $cellJ9 = $worksheet->getCell('J9');//CNPJ 8 valor
            $cellL9 = $worksheet->getCell('L9');//CNPJ 9
            $cellM9 = $worksheet->getCell('M9');//CNPJ 9 valor
            $cellO9 = $worksheet->getCell('O9');//CNPJ 10
            $cellP9 = $worksheet->getCell('P9');//CNPJ 10 valor*/
            $inicial =  gmdate('d/m/Y', ((int)$cellD3->getValue() - 25569) * 86400);
            $final =  gmdate('d/m/Y', ((int)$cellD4->getValue() - 25569) * 86400);
            $params = [
            "CDCOMPRADOR" => str_pad($cellB6->getValue(), 12, '0', STR_PAD_LEFT),
            "DTVALIDADEINICIAL" => $inicial,
            "DTVALIDADEFINAL" => $final,
            "STATUS" => 'PENDENTE',
            "DTIMPORTACAO" => date("d/m/Y"),
            "RESPONSAVEL" => $cellM2->getValue(),
            "DSARQUIVO" => $cellC1->getValue(),
            "CDOPERLOGADO" => $this->environment->getCdoperador()
            ];
            $searchRFPMAIN = [
            "CDCOMPRADOR" => str_pad($cellB6->getValue(), 12, '0', STR_PAD_LEFT),
            "DTVALIDADEINICIAL" => $inicial,
            "DTVALIDADEFINAL" => $final,
            "RESPONSAVEL" => $cellM2->getValue()
            ];
            $searchNR = $this->searchNRRFPMAIN($searchRFPMAIN);
            $searchStatus = $this->searchSTATUS($searchRFPMAIN);
            if($searchNR /* empty($searchNR)*/) {
                $search = $this->getCompradorCadastrado($params["CDCOMPRADOR"]);
                if(!empty(array_filter($search))) {
                //$this->insertRFPMAIN($params);
                $result = ['MESSAGE' => 'SUCCESS'];
                }
                else $result = ['MESSAGE' => 'COMPRADOR_N_CADASTRADO'];
            }
            else if($searchStatus == 'PENDENTE'){
                
            }else $result = ['MESSAGE' => 'IMPOSSIVEL_ADICIONAR'];
            return $result;
    }

    public function readXls($row){
        try {
            $file = $row['FILE'];
            
            $sheetsToLoad = array('Sheasdasdsadet1', 'Sheet1', 'Planilha1');
            $xlsFile = FileLoader::loadFromBase64($file['content'], $file['name']);
            if(!$xlsFile){
                throw new \Exception(self::IMPORT_LOAD_FILE_ERROR);
            }
            $columnNames = ["CÓDIGO", "DESCRIÇÃO", "CÓDIGO", "NOME", "PREÇO", "CÓDIGO", "NOME", "PREÇO","CÓDIGO", "NOME", "PREÇO","CÓDIGO", "NOME", "PREÇO"];
            $worksheet = $xlsFile->getActiveSheet();
            $cellB6 = $worksheet->getCell('B6');//Codigo comprador valor
            $cellM2 = $worksheet->getCell('M2');//Responsavel Nome
            $cellD3 = $worksheet->getCell('D3');//Validade Inicial
            $cellD4 = $worksheet->getCell('D4');//Validade Final
            $inicial =  gmdate('d/m/Y', ((int)$cellD3->getValue() - 25569) * 86400);
            $final =  gmdate('d/m/Y', ((int)$cellD4->getValue() - 25569) * 86400);
            $searchRFPMAIN = [
            "CDCOMPRADOR" => str_pad($cellB6->getValue(), 12, '0', STR_PAD_LEFT),
            "DTVALIDADEINICIAL" => $inicial,
            "DTVALIDADEFINAL" => $final,
            "RESPONSAVEL" => $cellM2->getValue()
            ];
            $table = $this->formatXls($worksheet, $columnNames, $searchRFPMAIN);
            if(!empty($table)) {
                $result = ['MESSAGE' => 'SUCCESS'];
            }
            return $result;
        } catch (\Exception $e){
            throw $e;
        }
    }
    
    protected static function getColumnIndex($column){
        if(gettype($column) == 'string')
            return PHPExcel_Cell::columnIndexFromString($column) - 1 ;
        else
            return $column;
    }
    
    protected static function isHeaderSizeRight($maxColumn, $columnNames){
        return ($maxColumn == count($columnNames) - 1);  
    }
    
    protected static function getColumnString($column){
        if(gettype($column) == 'integer')
            return PHPExcel_Cell::stringFromColumnIndex($column);
        else
            return $column;
    }
    
    protected static function buildColumnNameReference($worksheet, $maxColumn, $columnNames){
        $reference = array();
            for($column = 0; $column <= $maxColumn; $column++){
                $columnString = self::getColumnString($column);
                $columnName = $worksheet->getCell($columnString.'1')->getValue();
                $reference[$columnString] = mb_strtoupper($columnName, 'UTF-8');
            }
        return ($reference);
    }
    
    public function formatXls(PHPExcel_Worksheet $worksheet, $columnNames, $searchRFPMAIN){
        $nrrfp = $this->searchNRRFPMAIN($searchRFPMAIN);
        //
        $codigo = null;
        $codigomarca1 = null;
        $nomemarca1 = null;
        $precomarca1 = null;
        $codigomarca2 = null;
        $nomemarca2 = null;
        $precomarca2 = null;
        $codigomarca3 = null;
        $nomemarca3 = null;
        $precomarca3 = null;
        $codigomarca4 = null;
        $nomemarca4 = null;
        $precomarca4 = null;
        $codigomarca5 = null;
        $nomemarca5 = null;
        $precomarca5 = null;
        //
        $minRowIndex = 14;
        $worksheetDimensions = $worksheet->getHighestRowAndColumn();
        $maxRowIndex = $worksheetDimensions['row'];
        $maxColumnIndex = self::getColumnIndex($worksheetDimensions['column']);
        $columnsReference = self::buildColumnNameReference($worksheet, $maxColumnIndex, $columnNames);
        $tableRows = array();
        for($row = $minRowIndex; $row <= $maxRowIndex; $row++){
            $worksheetRowContent = array();
            $rowIsEmpty = true;
            for($column = 0; $column <= $maxColumnIndex; $column++){
                $columnLetterIndex = PHPExcel_Cell::stringFromColumnIndex($column);
                $columnName = $columnsReference[$columnLetterIndex];
                $cellValue = $worksheet->getCell($columnLetterIndex.$row)->getValue();
                if($cellValue !== NULL){
                    $rowIsEmpty = false;
                    $cellValue = $worksheet->getCell($columnLetterIndex.$row)->getFormattedValue();
                    if($columnLetterIndex == "A") {
                        $codigo = $cellValue;
                    } else if($columnLetterIndex == "B"){
                        $descricao = $cellValue;
                    } else if($columnLetterIndex == "C"){
                        $codigomarca1 = $cellValue;
                    } else if($columnLetterIndex == "D"){
                        $nomemarca1 = $cellValue;
                    } else if($columnLetterIndex == "E"){
                        $precomarca1 = $cellValue;
                    } else if($columnLetterIndex == "F"){
                        $codigomarca2 = $cellValue;
                    } else if($columnLetterIndex == "G"){
                        $nomemarca2 = $cellValue;
                    } else if($columnLetterIndex == "H"){
                        $precomarca2 = $cellValue;
                    } else if($columnLetterIndex == "I"){
                        $codigomarca3 = $cellValue;
                    } else if($columnLetterIndex == "J"){
                        $nomemarca3 = $cellValue;
                    } else if($columnLetterIndex == "K"){
                        $precomarca3 = $cellValue;
                    } else if($columnLetterIndex == "L"){
                        $codigomarca4 = $cellValue;
                    } else if($columnLetterIndex == "M"){
                        $nomemarca4 = $cellValue;
                    } else if($columnLetterIndex == "N"){
                        $precomarca4 = $cellValue;
                    } else if($columnLetterIndex == "O"){
                        $codigomarca5 = $cellValue;
                    } else if($columnLetterIndex == "P"){
                        $nomemarca5 = $cellValue;
                    } else if($columnLetterIndex == "Q"){
                        $precomarca5 = $cellValue;
                    }
                } else {
                    if(($columnLetterIndex == "A" || $columnLetterIndex == "C" || $columnLetterIndex == "D" || $columnLetterIndex == "E")&&($cellValue == NULL)){
                        $this->setError($row, $columnName, $cellValue, "NAO_INFOR");
                    }
                }
                $worksheetRowContent = array_merge($worksheetRowContent, array($columnName => $cellValue));
            }
            $p1 = substr($precomarca1, 3, -1);
            $p2 = substr($precomarca2, 3, -1);
            $p3 = substr($precomarca3, 3, -1);
            $p4 = substr($precomarca4, 3, -1);
            $p5 = substr($precomarca5, 3, -1);
            if(!$rowIsEmpty){
                $params = [
                "NRRFPMAIN" => intval($nrrfp),
                "CDPRODUTO" => $codigo,
                "CDPRODIMP1" => $codigomarca1,
                "NMPRODIMP1" => $nomemarca1,
                "VRPRECO1" => $p1,
                "CDPRODIMP2" => $codigomarca2,
                "NMPRODIMP2" => $nomemarca2,
                "VRPRECO2" => $p2,
                "CDPRODIMP3" => $codigomarca3,
                "NMPRODIMP3" => $nomemarca3,
                "VRPRECO3" => $p3,
                "CDPRODIMP4" => $codigomarca4,
                "NMPRODIMP4" => $nomemarca4,
                "VRPRECO4" => $p4,
                "CDPRODIMP5" => $codigomarca5,
                "NMPRODIMP5" => $nomemarca5,
                "VRPRECO5" => $p5
                ];
                $worksheetRow = array(
                    'index' => $row,
                    'content' => $worksheetRowContent
                );
                array_push($tableRows, $worksheetRow);
            }
            //$this->insertRFPPRODMARCA($params);
        }
        $table = new Table($columnsReference, $tableRows);
        $rowsFromTable = $table->getRows();
        if($this->errors != null){
            $rowsFromTable['ERROS'] = $this->errors;
        }
        return $rowsFromTable;
    }
    
    public function insertRFPMAIN($row) {
        $query = $this->entityManager->getConnection()->prepare(
        "INSERT
         INTO RFPMAIN (
            NRRFPMAIN,
            CDCOMPRADOR,
            DTVALIDADEINICIAL,
            DTVALIDADEFINAL,
            STATUS,
            DTIMPORTACAO,
            RESPONSAVEL,
            DSARQUIVO,
            CDOPERLOGADO) 
        VALUES (
            SEQ_RFPMAIN_NRRFPMAIN.NEXTVAL,
            :CDCOMPRADOR,
            :DTVALIDADEINICIAL,
            :DTVALIDADEFINAL,
            :STATUS,
            :DTIMPORTACAO,
            :RESPONSAVEL,
            :DSARQUIVO,
            :CDOPERLOGADO)"
            );
            $query->execute(
                array(
                    "CDCOMPRADOR" => $row["CDCOMPRADOR"],
                    "DTVALIDADEINICIAL" => $row["DTVALIDADEINICIAL"],
                    "DTVALIDADEFINAL" => $row["DTVALIDADEFINAL"],
                    "STATUS" => $row['STATUS'],
                    "DTIMPORTACAO" => $row["DTIMPORTACAO"],
                    "RESPONSAVEL" => $row["RESPONSAVEL"],
                    "DSARQUIVO" => $row["DSARQUIVO"],
                    "CDOPERLOGADO" => $row["CDOPERLOGADO"],
                )
            );
    }
    public function insertRFPPRODMARCA($row) {
        $query = $this->entityManager->getConnection()->prepare(
        "INSERT
         INTO RFPPRODMARCA (
            NRRFPPRODMARCA,
            NRRFPMAIN,
            CDPRODUTO,
            CDPRODIMP1,
            NMPRODIMP1,
            VRPRECO1,
            CDPRODIMP2,
            NMPRODIMP2,
            VRPRECO2,
            CDPRODIMP3,
            NMPRODIMP3,
            VRPRECO3,
            CDPRODIMP4,
            NMPRODIMP4,
            VRPRECO4,
            CDPRODIMP5,
            NMPRODIMP5,
            VRPRECO5) 
        VALUES (
            SEQ_RFPPRODMARCA_NRRFPPRDMARCA.NEXTVAL,
            :NRRFPMAIN,
            :CDPRODUTO,
            :CDPRODIMP1,
            :NMPRODIMP1,
            :VRPRECO1,
            :CDPRODIMP2,
            :NMPRODIMP2,
            :VRPRECO2,
            :CDPRODIMP3,
            :NMPRODIMP3,
            :VRPRECO3,
            :CDPRODIMP4,
            :NMPRODIMP4,
            :VRPRECO4,
            :CDPRODIMP5,
            :NMPRODIMP5,
            :VRPRECO5)"
            );
            $query->execute(
                array(
                    "NRRFPMAIN" => $row["NRRFPMAIN"],
                    "CDPRODUTO" => $row["CDPRODUTO"],
                    "CDPRODIMP1" => $row["CDPRODIMP1"],
                    "NMPRODIMP1" => $row['NMPRODIMP1'],
                    "VRPRECO1" => $row["VRPRECO1"],
                    "CDPRODIMP2" => $row["CDPRODIMP2"],
                    "NMPRODIMP2" => $row['NMPRODIMP2'],
                    "VRPRECO2" => $row["VRPRECO2"],
                    "CDPRODIMP3" => $row["CDPRODIMP3"],
                    "NMPRODIMP3" => $row['NMPRODIMP3'],
                    "VRPRECO3" => $row["VRPRECO3"],
                    "CDPRODIMP4" => $row["CDPRODIMP4"],
                    "NMPRODIMP4" => $row['NMPRODIMP4'],
                    "VRPRECO4" => $row["VRPRECO4"],
                    "CDPRODIMP5" => $row["CDPRODIMP5"],
                    "NMPRODIMP5" => $row['NMPRODIMP5'],
                    "VRPRECO5" => $row["VRPRECO5"]
                )
            );
    }
    public function searchNRRFPMAIN($row){
        $sql = "
        SELECT
            NRRFPMAIN
        FROM
            RFPMAIN
        WHERE
            RESPONSAVEL = :RESPONSAVEL
            AND DTVALIDADEINICIAL = :DTVALIDADEINICIAL
            AND DTVALIDADEFINAL = :DTVALIDADEFINAL
            AND CDCOMPRADOR = :CDCOMPRADOR";
        $params = array(
                    "CDCOMPRADOR" => $row["CDCOMPRADOR"],
                    "DTVALIDADEINICIAL" => $row["DTVALIDADEINICIAL"],
                    "DTVALIDADEFINAL" => $row["DTVALIDADEFINAL"],
                    "RESPONSAVEL" => $row["RESPONSAVEL"],
            );
        $answer = $this->entityManager->getConnection()->fetchAll($sql, $params);
        return $answer[0]['NRRFPMAIN'];
    }
    public function searchSTATUS($row){
        $sql = "
        SELECT
            STATUS
        FROM
            RFPMAIN
        WHERE
            RESPONSAVEL = :RESPONSAVEL
            AND DTVALIDADEINICIAL = :DTVALIDADEINICIAL
            AND DTVALIDADEFINAL = :DTVALIDADEFINAL
            AND CDCOMPRADOR = :CDCOMPRADOR";
        $params = array(
                    "CDCOMPRADOR" => $row["CDCOMPRADOR"],
                    "DTVALIDADEINICIAL" => $row["DTVALIDADEINICIAL"],
                    "DTVALIDADEFINAL" => $row["DTVALIDADEFINAL"],
                    "RESPONSAVEL" => $row["RESPONSAVEL"],
            );
        $answer = $this->entityManager->getConnection()->fetchAll($sql, $params);
        return $answer[0]['STATUS'];
    }
    public function getCompradorCadastrado($cdoperador){
        $params = array(
                "CDOPERADOR" => $cdoperador
        );
        
        $sql = "SELECT CDOPERADOR FROM COMPRADOR C WHERE
            C.CDOPERADOR = :CDOPERADOR";
                    
        $answer = $this->entityManager->getConnection()->fetchAll($sql, $params);
        return $answer;
    }
}